﻿/* 
(C) OOMusou 2011 http://oomusou.cnblogs.com

Filename    : use_delegate.v
Compiler    : Visual Studio 2008
Description : delegate by C# 1.0
Release     : 02/12/2011 1.0
*/

using System;
using System.IO;

delegate void display_method(string s); // declare delegate class type

class use_delegate {
  static void Main(string[] args) {
    Console.WriteLine("1:write to console, 2:write to text");
    int i = Console.Read();
    string s = "Hello World";

    display_method m; // instantiate delegate object m
    if (i == 49) // ACSII 1
      m = write_to_console; // assign method to delegate object
    else
      m = write_to_file;

    display_message(m, s); // use delegate to pass a method
  }

  static void write_to_console(string s) {
    Console.WriteLine(s);
  }

  static void write_to_file(string s) {
    using (StreamWriter sw = new StreamWriter("test.txt"))
      sw.WriteLine(s);
  }

  static void display_message(display_method m, string s) {
    m(s); // use delegate to call method
  }
}
